#!/bin/sh
echo "*** Cleaning Script  (To be called before commiting to CVS)***"

echo "Deleting pyc files..."
for file in $(find ./ -name "*.pyc")
  do
    rm $file
  done

echo "Deleting backup files..."
for file in $(find ./ -name "*~")
  do
    rm $file
  done    

echo "Counting lines..."
lines=0
for file in $(find ./ -name "*.py")
  do
    case $file in
       "./gui/SSGridViewStateChart.py") :;; #not written by MP
       "./formulaparser/yappsrt.py") :;; #not written by MP
       "./formulaparser/Parser.py") :;; #not written by MP
       *) set $(wc -l $file)
           lines=$(($lines + $1))
           ;;
    esac
  done

unset file

if [ ${file:=$(find ./ -name "SSGridViewStateChart.des")} ]
then
  set $(wc -l $file)
  lines=$(($lines + $1))
fi

unset file

if [ ${file:=$(find ./ -name "FormulaParser.g")} ]
then
  set $(wc -l $file)
  lines=$(($lines + $1))
fi
  
echo "This program contains approx ${lines} lines of code and comments written by MP"  

exit 0