""" Parse node, element of a parse tree.
    @author: Marc Provost
    @organization: McGill University
    @license: GNU General Public License
    @contact: marc.provost@mail.mcgill.ca    
"""

class ParseNode:
  """ Class used to create a parse tree
  """

  def __init__(self, kind, data=None):
    """ ParseNode's constructor
        @param kind: Kind of token (e.g., exp, number, etc)
        @param data: Data related to the token (e.g. number -> 4.5)
        @type kind: string
        @type data: string
    """
    self.children=[]
    self.strData=str(data)
    self.kind=str(kind)

  def __str__(self):
    return self.kind + " :: " + self.strData

