import sys
from math import pow
from utility.ErrorUtility import ErrorUtility
errHandler=ErrorUtility.getInstance()

class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable

class ColumnConvertUtility:
  instance=None #private
        
  def __init__(self, debug=1):
    if ColumnConvertUtility.instance!=None:
      r=RunTimeError("Singleton ColumnConvertUtility is already instantiated")
      errHandler.exceptionRaised(r)
  
  def getInstance():
    if ColumnConvertUtility.instance==None:
      ColumnConvertUtility.instance=ColumnConvertUtility()
    return ColumnConvertUtility.instance
  getInstance=Callable(getInstance)  
  
  
  def stringToInt(self,col):
    """
      Function used to transform strings used
      cell column references (e.g. A5) to integers
      for efficiency reasons.  Note that 0 are removed
      from possible integers to avoid ambiguity.
      (i.e. if "A" is converted to 0, "AAA"=000=0,
      0==0 while "A" != "AAA").
    """
    base=ord("A")
    answer=0
    for l in xrange(len(col)):
      answer+=(ord(col[-(l+1)])-base+1)*int(pow(26,l))
    return answer-1
    
  def intToString(self,integer):
    """ 
      Invert function of stringToInt()
    """
    integer+=1
    ans=""
    base=ord("A")
    for order in xrange(6,-1,-1): #[2,1,0]:
      curMaxValue=int(pow(26,order))
      curValue=integer
      for j in xrange(order): #[0, ..., order-1]
        curValue-=int(pow(26,j))
      if curMaxValue<=curValue or order==0:
        charValue=(curValue-curValue%curMaxValue)/curMaxValue
        integer=integer-charValue*curMaxValue
        char=chr(charValue+base-1)
        ans+=char
    return ans