from utility.TypeCheckUtility import TypeCheckUtility
from utility.ErrorUtility import ErrorUtility
from utility.ColumnConvertUtility import ColumnConvertUtility

import unittest
import sys

from math import pow
from math import fabs

from random import randint
from random import seed

TRUE=1
FALSE=0
SEED=666

MINNUM=-1000
MAXNUM=1000

seed(666)

typeChecker = TypeCheckUtility.getInstance()
errHandler  = ErrorUtility.getInstance()
converter   = ColumnConvertUtility.getInstance()

errHandler.setTesting()

class TypeCheckerTestSuite(unittest.TestCase):
  
  def testTypeCheckerUtilitySuccess(self):
    """ Testing type checking for success (not implemented)
    """
    pass

  def testTypeCheckerUtilityFailure(self):
    """ Testing type checking for failure (not implemented)
    """ 
    pass
    
class ErrorUtilityTestSuite(unittest.TestCase):
  
  def testErrorUtilitySuccess(self):
    """ Testing error utility for success (not implemented)
    """
    pass

  def testErrorUtilityFailure(self):
    """ Testing error utility for failure (not implemented)
    """ 
    pass 
    
class ColumnConvertTestSuite(unittest.TestCase):

  sampleIntToString = [(0,'A'), (1,'B'), (10, 'K'), (25, 'Z'), (26, 'AA'),
                        (27, 'AB'), (30, 'AE'), (31, 'AF'), (32, 'AG'),
                        (33, 'AH'), (51, 'AZ'), (52,'BA'), (53, 'BB'),
                        (54, 'BC'), (78, 'CA'), (26*26, 'ZA'), 
                        (26*26+25, 'ZZ'), (26*26+26, "AAA"),
                        (26*26+27, "AAB"), (26*26*26+26*26+25,'ZZZ')]
  def testUtilsIntToStringSuccess(self):
    """ testing utility intToString for success
    """
    for sample in self.sampleIntToString:
      convertedVal=converter.intToString(sample[0])
      self.assertEqual(convertedVal,sample[1],
                                "IntToString converts incorrectly: "+\
                                str(convertedVal)+" != "+str(sample[1]))

  def testUtilsStringToIntSuccess(self):
    """testing utility stringToInt for success
    """
    for sample in self.sampleIntToString:
      convertedVal=converter.stringToInt(sample[1])
      self.assertEqual(convertedVal,sample[0],
                                "IntToString converts incorrectly: "+\
                                str(convertedVal)+" != "+str(sample[0]))  

  def testUtilsStringToIntSanity(self):
    """testing stringToInt/intToString for sanity
    """
    for val in xrange(0,25000):
      stringVal=converter.intToString(val)
      sanityVal=converter.stringToInt(stringVal)
      self.assertEqual(val,sanityVal,
                                  "Sanity test failed for string conversions: "+\
                                  str(val)+" != "+str(sanityVal))               

                

if __name__ == "__main__":
  unittest.main()                                 